/*
 * Main author(s) : Jean-Noël Monette
 * 
 * Copyright (c) 2013, Jean-Noël Monette
 * All rights reserved.

 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package convexPairs.inoscar.tests

import oscar.cp.modeling._
import oscar.cp.core._
import convexPairs.inoscar.modeling.Constraints

object TestFullSearchSpread extends App with Constraints {
	 //def main(args: Array[String]) {
     var S1 = List[String]();
     var S2 = List[String]();
      def testOrig(n:Int, m:Int):Int = {
      	S1 = List[String]();
      	val cp = CPSolver(); 
      	val nd = CPVarInt(cp,0 to m);
      	val rng = 0 until n;
      	//println("\nbef"+System.currentTimeMillis());
      	val x = for(i <- rng) yield CPVarInt(cp,-100 to 100);
      	//println("aft"+System.currentTimeMillis());
        //cp.add(deviationMy(x, 0, nd ))
      	val t1 = System.currentTimeMillis();
      	
      	var nbsol = 0
      	cp.solve subjectTo {
      		cp.add(spread(x, 1, nd ));
//      		cp.add(x(0)== -1);
//      		cp.add(x(1)==0);
//      		cp.add(x(2)==0);
//      		cp.add(x(3)==0);
//      		cp.add(x(4)==0);
      		println(x.mkString(","));
      		println("nd "+nd)
      	} exploration {        
        /*for (y <- rng.suspendable) {
          cp.branchAll(1 to n)(v => cp.post(x(y) == v))
        }*/
      	cp.binary(x);
//      		println(x.mkString(","));
        nbsol += 1;
        S1 = (x.mkString(",") :: S1);
      } run()
        
        val t2 = System.currentTimeMillis();
//        println(x.mkString(","));
//        println(nd);
        print("orig: "+(t2-t1)+"\t");
        print("bkts: "+cp.bkts+"\t");
        //print(nbsol)
        return nbsol;
      	}
      
      def testNew(n:Int, m:Int):Int = {	
      	S2 = List[String]();
      	val cp = CPSolver(); 
      	val nd = CPVarInt(cp,0 to /*n*n* */m);
      	val rng = 0 until n;
      	//println("\nbef"+System.currentTimeMillis());
      	val x = for(i <- rng) yield CPVarInt(cp,-100 to 100);
      	//println("aft"+System.currentTimeMillis());
      	val t1 = System.currentTimeMillis();
      	//println("t1"+t1);
        var nbsol = 0
      	cp.solve subjectTo {
//      		cp.add(x(0)==1);
//      		cp.add(x(1)==1);
//      		cp.add(x(2)==0);
//      		cp.add(x(3)==0);
//      		cp.add(x(4)==0);
//      		cp.add(x(5)==1);
      		//cp.add(spreadMy(x, 0, nd ));
      		cp.add(spread2(x, 1, nd ));
      		println(x.mkString(","));
      		println("nd "+nd)
      		/*cp.add(x(0)==0);
      		println(x.mkString(","));
      		cp.add(x(1)==2);
      		println(x.mkString(","));*/
      	} exploration {
      	cp.binary(x);
//      	println(x.mkString(","));
        S2 = (x.mkString(",") :: S2);
        nbsol += 1
      } run()
      	val t2 = System.currentTimeMillis();
        //cp.add(deviation(x, 0, nd ));
//        println(x.mkString(","));
//        println(nd);
        print("new: "+(t2-t1)+"\t");
        print("bkts: "+cp.bkts+"\t");
//        cp.printStats
        return nbsol
      	}
      	
      var i=10;
      var j=3;
      while(j< 4 && i<200){
      	print(i+"\t");
      	print(j+"\t");
    	  val n0 = testOrig(i,j);
    	  val n1 = testNew(i,j);
    	  i=i+10;
    	  //j=j+1;

    	  println(n0 +" "+n1);
    	  println();
    	  print(S2.filter(x => !S1.contains(x)).mkString("\n"));
    	  if(n0 != n1){
    	  	print(S2.filter(x => !S1.contains(x)).mkString("\n"));
    		  print("PROBLEM ");
    		  System.exit(0);
    	  }    	  
      }
}